/*
 * CDDL HEADER START
 *
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License (the "License").
 * You may not use this file except in compliance with the License.
 *
 * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
 * or http://www.opensolaris.org/os/licensing.
 * See the License for the specific language governing permissions
 * and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 * CDDL HEADER END
 */

/*
 * Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */

hotspot$target:::method-entry
{
        /* class name */
        self->str_ptr = (char*)copyin(arg1, arg2 + 1);
        self->str_ptr[arg2] = '\0';
        self->class = (string)self->str_ptr;

        /* method name */
        self->str_ptr = (char*)copyin(arg3, arg4 + 1);
        self->str_ptr[arg4] = '\0';
        self->method = (string)self->str_ptr;

        /* signature */
        self->str_ptr = (char*)copyin(arg5, arg6 + 1);
        self->str_ptr[arg6] = '\0';
        self->signature = (string)self->str_ptr;

        self->ptr = 0;
}

hotspot$target:::method-entry
??P0??
{
        self->times[??T??] = timestamp;
}

hotspot$target:::method-entry
{
        self->class_name = 0;
        self->method_name = 0;
        self->signature = 0;
}

hotspot$target:::method-return
{
        /* class name */
        self->str_ptr = (char*)copyin(arg1, arg2 + 1);
        self->str_ptr[arg2] = '\0';
        self->class = (string)self->str_ptr;

        /* method name */
        self->str_ptr = (char*)copyin(arg3, arg4 + 1);
        self->str_ptr[arg4] = '\0';
        self->method = (string)self->str_ptr;

        /* signature */
        self->str_ptr = (char*)copyin(arg5, arg6 + 1);
        self->str_ptr[arg6] = '\0';
        self->signature = (string)self->str_ptr;

        self->str_ptr = 0;
}

hotspot$target:::method-return
??P1??
{
        @method_times[??T??] =
            sum(timestamp - self->times[??T??]);
        self->times[??T??] = 0;
}

hotspot$target:::method-return
{
        self->class_name = 0;
        self->method_name = 0;
        self->signature = 0;
}

??T0 self->class
??T1 self->method
??T2 self->signature
??P0
??P1 self->times[??T??]
